﻿$('#policyPage').live('pageshow', function (event) {
    if (!navigator.onLine) {
        showAlert('Please make sure you are connected to a network and have access to the internet.');
    }
    $('input#loginEmail').focus();
});

var loginTimeout = null;

function login() {
    var userName = $('#loginPage #loginEmail').val();
    var password = $('#loginPage #loginPassword').val();

    if (userName.length <= 0 || $('#loginPage #loginPassword').val().length <= 0) {
        showAlert('Please enter your email and password.');
    }
    else if (!navigator.onLine) {
        showAlert('Please make sure you are connected to a network and have access to the internet.');
    }
    else {
        $.mobile.showPageLoadingMsg();
        $.ajax({
            type: 'POST',
            url: serviceUrl + '/Login',
            crossDomain: true,
            contentType: "application/json",
            dataType: "json",
            data:JSON.stringify({ "userName": userName, "password": password }),
            success: function (data) { loginComplete(data); },
            error: function (xhr, status, err) { loginComplete(null); /*alert("error=" + xhr.responseText);*/ }
        });
        loginTimeout = setTimeout(function () { loginComplete(null); }, 10000);
    }
}

function loginComplete(session) {
    if (loginTimeout)
        clearTimeout(loginTimeout);
    $.mobile.hidePageLoadingMsg();
    if (session && session.LoggedIn) {
        this.session = session;
        $.mobile.changePage('#policyPage');
    }
    else {
        this.session = null;
        showAlert('Your Email and/or Password could not be verified. Please try again.');
    }
}