﻿$('#policyPage').live('pageshow', function (event) {
    //session = { LoggedIn: true, SessionToken: '1D96FCB1-403E-4267-A5A5-D9A9B0721DA2', UserFullName: 'Chris Ward', CompanyName: 'Kbase Connect' };
    if (!session || !session.LoggedIn) {
        $.mobile.changePage('#loginPage', { reloadPage: true });
        return;
    }

    if (folderPath == null) {
        folderLevel = 1;
        folderPath = [{ ID: 0, Name: 'Policies'}];
    }

    $("#policySearchInput").bind('change', doSearch);

    resizePolicyPage();
    clearPolicyPage();
});

$(window).resize(function () {
    if ($.mobile.activePage.attr('id') == 'policyPage')
        resizePolicyPage();
});

function resizePolicyPage() {
    if ($(window).width() >= 1000) {
        largeScreen = true;
        $('div#policyPage').addClass('largeScreen');
        showPolicyNavigation();
    }
    else {
        largeScreen = false;
        $('div#policyPage').removeClass('largeScreen');
        hidePolicyNavigation();
    }
}

function clearPolicyPage() {
    $('div#policyContent').hide();
    $('div#policyWelcome').show();

    $('div#policyWelcome').html('');
    $('div#policyWelcome').append('<h2>Hi ' + session.UserFullName + ',<br/>welcome to</h2>');
    $('div#policyWelcome').append('<img src="assets/images/policy-central.png" />');
    $('div#policyWelcome').append('<h2>for ' + session.CompanyName + '</h2>');
    if (!largeScreen)
        $('div#policyWelcome').append('<a data-role="button" data-mini="true" href="#policyPage" onclick="javascript:showPolicyNavigation();">Click here to start viewing your policies</a>');
    $('div#policyWelcome a').button();
}

function setFolder(folderLevel, folderID, folderName) {
    setPolicyNavigation(navType);
    this.folderLevel = folderLevel;
    this.policyID = null;
    if (folderLevel > 1) {
        this.folderPath[folderLevel - 1] = new Object({ ID: folderID, Name: folderName });
    }
    getFolderContents();
}

function getFolderContents() {
    $.mobile.showPageLoadingMsg();
    $.getScript(serviceUrl + '/GetFolderContents?callback=getFolderContentsComplete&sessionToken=' + session.SessionToken + '&folderID=' + folderPath[folderLevel - 1].ID);    
}

function getFolderContentsComplete(data) {
    $('#folderItemList li').remove();
    $.each(data, function (index, folderItem) {
        var indentClass = 'indent' + (folderLevel + 1);
        if (folderItem.IsFolder == true) {
            $('#folderItemList').append('<li class="' + indentClass + '"><a href="#policyPage" onclick="javascript:setFolder(' + (folderLevel + 1) + ',' + folderItem.ID + ',\'' + folderItem.Name + '\');"><img src="assets/images/folder.gif" class="ui-li-icon" />' + folderItem.Name + '</a></li>');
        }
        else if (folderItem.IsPolicy == true) {
            $('#folderItemList').append('<li class="' + indentClass + '"><a href="#policyPage" onclick="javascript:setPolicy(\'' + folderItem.ID + '\');"><img src="assets/images/policy.gif" class="ui-li-icon" />' + folderItem.Name + '</a></li>');
        }
    });
    $('#folderItemList').listview('refresh');
    updateFolderPath();
    setPolicyNavigation(navType);
    $.mobile.silentScroll(0);
    $.mobile.hidePageLoadingMsg();
}

function setPolicy(policyID) {
    setPolicyNavigation(navType);
    this.policyID = policyID;
    if (!largeScreen)
        hidePolicyNavigation();
    getPolicy();
    $('div#policyContent').show();
    $('div#policyWelcome').hide();
}

function getPolicy() {
    $.mobile.showPageLoadingMsg();
    $.getScript(serviceUrl + '/GetPolicy?callback=getPolicyComplete&sessionToken=' + session.SessionToken + '&policyID=' + policyID);
}

function getPolicyComplete(policy) {
    $('div#policyContent').html('');

    $('div#policyContent').append('<h2>' + policy.Name + '</h2>');

    $('div#policyContent').append('<ul id="policySectionList" data-role="listview" data-inset="true" data-mini="true" data-filter="false"></ul>');
    $('div#policyContent').trigger("create");
    $.each(policy.Sections, function (index, section) {
        $('#policySectionList').append('<li><a href="#policyPage" onclick="javascript:gotoAnchor(\'Element_' + section.ID + '\');">' + section.Heading + '</a></li>');
    });
    $('#policySectionList').listview('refresh');

    $.each(policy.Sections, function (index, section) {
        $('div#policyContent').append('<a class="upButton" href="#policyPage" onclick="javascript:$.mobile.silentScroll(0);" data-role="button" data-iconpos="notext" data-mini="true" data-inline="true" data-icon="arrow-u"></a>');
        $('div#policyContent a.upButton').button();
        if (section.ShowHeading)
            $('div#policyContent').append('<a name="Element_' + section.ID + '"><h3>' + section.Heading + '</h3></a>');
        else
            $('div#policyContent').append('<a name="Element_' + section.ID + '"></a>');
        $('div#policyContent').append(section.Content + '<br/>');
    });
    setPolicyNavigation(navType);
    $.mobile.silentScroll(0);
    $.mobile.hidePageLoadingMsg();
}

function gotoAnchor(anchor) {
    var target = $('a[name$=' + anchor + ']');
    if (target.length)
        $.mobile.silentScroll(target.get(0).offsetTop);
}

function updateFolderPath() {
    $('#folderPath li').remove();
    for (var i = 0; i < folderLevel; i++) {
        var folder = folderPath[i];
        var indentClass = 'indent' + (i + 1);
        $('#folderPath').append('<li class="' + indentClass + '"><a href="#policyPage" onclick="javascript:setFolder(' + (i + 1) + ',' + folder.ID + ',\'' + folder.Name + '\');" data-icon="arrow-d"><img src="assets/images/folder.gif" class="ui-li-icon" />' + folder.Name + '</a></li>');
    }
    $('#folderPath').listview('refresh');
    $('#folderPath li span.ui-icon').removeClass('ui-icon-arrow-r').addClass('ui-icon-arrow-d');
}

function togglePolicyNavigation() {
    if (!$('div#policyNavigation').is(":visible"))
        showPolicyNavigation();
    else
        hidePolicyNavigation();
}

function showPolicyNavigation() {
    if (navType == null)
        setPolicyNavigation('nav');
    $('div#policyNavigation').slideDown();
    $('#policyNavigationButton span.ui-icon').removeClass('ui-icon-arrow-d').addClass('ui-icon-arrow-u');
    if (largeScreen)
        $('div#policyPage').addClass('largeScreen');
    
    $('a#policyNavigationButton').trigger('create');
    setPolicyNavigation(navType);
}

function hidePolicyNavigation() {
    $('div#policyNavigation').slideUp();
    $('#policyNavigationButton span.ui-icon').removeClass('ui-icon-arrow-u').addClass('ui-icon-arrow-d');
    $('div#policyPage').removeClass('largeScreen');

    $('a#policyNavigationButton').trigger('create');
    setPolicyNavigation(navType);
}

function setPolicyNavigation(navType) {
    if (this.navType != navType) {
        this.navType = navType;
        $('#policyPage div#policyNavigation div#policyNav').slideUp();
        $('#policyPage div#policyNavigation div#policySearch').slideUp();
        $('#policyPage div#policyNavigation div#policyIndex').slideUp();
        if (navType == 'nav') {
            getFolderContents();
            $('#policyPage div#policyNavigation div#policyNav').slideDown();
        }
        else if (navType == 'search')
            $('#policyPage div#policyNavigation div#policySearch').slideDown();
        else if (navType == 'index') {
            getIndex();
            $('#policyPage div#policyNavigation div#policyIndex').slideDown();
        }
    }
    $('#policyPage div#policyNavigation div#policyNavBar a#navTab').removeClass('ui-btn-active');
    $('#policyPage div#policyNavigation div#policyNavBar a#searchTab').removeClass('ui-btn-active');
    $('#policyPage div#policyNavigation div#policyNavBar a#indexTab').removeClass('ui-btn-active');
    if (navType == 'nav')
        $('#policyPage div#policyNavigation div#policyNavBar a#navTab').addClass('ui-btn-active ui-state-persist');
    else if (navType == 'search')
        $('#policyPage div#policyNavigation div#policyNavBar a#searchTab').addClass('ui-btn-active ui-state-persist');
    else if (navType == 'index')
        $('#policyPage div#policyNavigation div#policyNavBar a#indexTab').addClass('ui-btn-active ui-state-persist');
}

function getIndex() {
    $.mobile.showPageLoadingMsg();
    $.getScript(serviceUrl + '/GetPoliciesIndex?callback=getIndexComplete&sessionToken=' + session.SessionToken);
}

function getIndexComplete(data) {
    $('#policyIndexList li').remove();
    $.each(data, function (index, folderItem) {
        $('#policyIndexList').append('<li><a href="#policyPage" onclick="javascript:setPolicy(\'' + folderItem.ID + '\');">' + folderItem.Name + '</a></li>');
    });
    $('#policyIndexList').listview('refresh');
    $.mobile.hidePageLoadingMsg();
}

function doSearch() {
    $('#policySearchList li').remove();
    $('#policySearchNoResults').hide();
    var search = $("input#policySearchInput").val();
    if (search.length > 1) {
        $.mobile.showPageLoadingMsg();
        $.getScript(serviceUrl + '/SearchPolicies?callback=doSearchComplete&sessionToken=' + session.SessionToken + '&search=' + search);
    }
}

function doSearchComplete(data) {
    $('#policySearchList li').remove();
    if (data.length == 0)
        $('#policySearchNoResults').show();
    $.each(data, function (index, folderItem) {
        $('#policySearchList').append('<li><a href="#policyPage" onclick="javascript:setPolicy(\'' + folderItem.ID + '\');">' + folderItem.Name + '</a></li>');
    });
    $('#policySearchList').listview('refresh');
    $.mobile.hidePageLoadingMsg();
}